/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/



// For jslib (jslib.mozdev.org), which is no longer being used.
//include('chrome://jslib/content/io/io.js');



// The active search (the one whose results are currently being displayed
// in the results pane).
var gActiveSearch = {};


// The default script and options for searching Bugzilla installations.
var gSearchOptions = "buglist.cgi?format=rdf&columnlist=all";

// The number of loading search results being tracked by the progress meter.
var gProgressCount = 0;



function loadPreferencesFile()
{
// Get the app directory service.
  var appDirectoryService = 
    Components
      .classes["@mozilla.org/file/directory_service;1"]
        .createInstance(Components.interfaces.nsIProperties);
  if ( !appDirectoryService ) 
    throw("loadPreferences: could not access the app directory service.");

  // Use the service to retrieve the user's profile directory and preferences file.
  var userProfileDir = appDirectoryService.get("ProfD", Components.interfaces.nsIFile);
  if ( !userProfileDir ) 
    throw ("loadPreferences: could not locate the user's profile directory");
  var prefsFile = userProfileDir.clone();
  prefsFile.append("bugxula.rdf");

  // Create the preferences file if it does not exist
  if ( !prefsFile.exists() )
  {
    prefsFile.create(prefsFile.NORMAL_FILE_TYPE, 0644);
    var file = fopen(prefsFile, MODE_WRONLY, 0644);
    file.write(
      '<?xml version="1.0"?>\n' + 
      '<RDF:RDF xmlns:bz="http://www.bugzilla.org/rdf#"\n' + 
      '        xmlns:NC="http://home.netscape.com/NC-rdf#"\n' + 
      '        xmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">\n' + 
      '  <RDF:Description about="urn:bugxula:root">\n' + 
      '    <bz:installations>\n' + 
      '      <RDF:Seq>\n' + 
      '        <RDF:li><bz:installation about="http://bugzilla.mozilla.org/" bz:name="mozilla.org" /></RDF:li>\n' + 
      '        <RDF:li><bz:installation about="http://bugscape.nscp.aoltw.net/" bz:name="bugscape" /></RDF:li>\n' + 
      '      </RDF:Seq>\n' + 
      '    </bz:installations>\n' + 
      '    <bz:queries><RDF:Seq></RDF:Seq></bz:queries>\n' + 
      '    <bz:active_results><RDF:Bag></RDF:Bag></bz:active_results>\n' + 
      '  </RDF:Description>\n' + 
      '</RDF:RDF>\n'
    );
    file.close();
  }

  // Get the file: URL of the preferences file since the RDF service needs it
  // to load the data source.
  //var foo, bar = {};
  //for (foo in Components.classes)
  //{
  //  if (foo.match("service")) bar += foo + "\n";
  //}
  //alert(bar);
  var IOService = 
    Components
      .classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);
  if ( !IOService ) 
    throw("loadPreferences: could not access the IO service.");
  var url = IOService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler).getURLSpecFromFile(prefsFile);

  // Load the preferences file as an RDF datasource and attach an observer
  // to handle the file once it has loaded.
  top.gUserDS = loadDataSource(url, PreferencesFileObserver);
}

// Initializes an in-memory data source to store global Bugxula settings.
/*
function initGlobalDS()
{
  gGlobalDS = new RDFDataSource(null, null, true);
  gGlobalDS.setNameSpace('rdf', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#');
  gGlobalDS.setNameSpace('bz', 'http://www.bugzilla.org/rdf#');
  var c = gGlobalDS.makeContainer("urn:bugxula:root", "bz:fields", "Seq");
  c.appendResource("urn:bugxula:field:" + name);
  gGlobalDS.assert();
//          <bz:field rdf:about="http://localhost/bztip/field.cgi?name=blocked">
//            <bz:name>blocked</bz:name>
//            <bz:description>OtherBugsDependingOnThis</bz:description>
//         </bz:field>
}
*/

function loadDataSource(url, observer)
{
  dd('loading data source: ' + url);

  var ds;
  if ( typeof RDFDataSource.all[url] != "undefined" ) 
    ds = RDFDataSource.all[url];
  else
  {
    ds = new RDFDataSource(url);
    ds.setNameSpace('rdf', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#');
    ds.setNameSpace('bz', 'http://www.bugzilla.org/rdf#');
  }

  ds.load(observer);
  
  return ds;
}


function incrementProgressMeter(amount)
{
  if (!amount) amount = 1;
  gProgressCount = gProgressCount + amount;
  
  var progressMeter = document.getElementById("statusbar-icon");
  progressMeter.setAttribute("mode", "undetermined");
}

function decrementProgressMeter()
{
  --gProgressCount;
  if (gProgressCount <= 0)
  {
    gProgressCount = 0;
    var progressMeter = document.getElementById("statusbar-icon");
    progressMeter.setAttribute("mode", "normal");
  }
  return(gProgressCount);
}

function resetProgressMeter()
{
  gProgressCount = 0;
  var progressMeter = document.getElementById("statusbar-icon");
  progressMeter.setAttribute("mode", "normal");
}


function activateSearch(uri, installations, conditions)
{
  // Initialize the search.
  if (uri)
  {
    // This search is saved, so get information about it from the user's data source.
    installations = gUserDS.getContainer(uri, 'bz:installations');
    conditions = gUserDS.getTarget(uri, "bz:conditions");
    name = gUserDS.getTarget(uri, "bz:name");
    gActiveSearch.uri = uri;
    gActiveSearch.isSaved = true;
    gActiveSearch.name = name;
  }
  else
  {
    gActiveSearch.uri = null;
    gActiveSearch.isSaved = false;
  }
  gActiveSearch.state = "loading";  
  gActiveSearch.conditions = conditions;
  
  // Build the list of installations being searched.
  gActiveSearch.installations = new Array();
  if (typeof installations == "object")
  {
    // I should be able to do the following, but for some reason it doesn't work:
    //if (installations.constructor == Array)
    if (typeof installations.hasMoreElements == "undefined")
    {
      for ( var i=0 ; i<installations.length ; i++ )
        gActiveSearch.installations.push(installations[i]);
    }
    else
    {
      while (installations.hasMoreElements())
        gActiveSearch.installations.push(installations.getNextElement());
    }
  }
  else
    gActiveSearch.installations.push(installations);
  
  updateSearchOptions();
  
  // Restore the columns in the results pane to the state they were in
  // the last time this search was run.
  if (typeof gActiveSearch.isSaved != "undefined" && gActiveSearch.isSaved) 
    restoreColumnSettings();
  
  // Load the results, adding each one to the RDF list of active results
  // so the composite database attached to the results tree can aggregate
  // them into a single list.
  var activeResults = getActiveResults();
  var installation, resultURI;
  for ( i=0 ; i<gActiveSearch.installations.length ; i++ )
  {
    resultURI = gActiveSearch.installations[i] + gSearchOptions + conditions;
    activeResults.appendResource(resultURI);
    incrementProgressMeter();
    loadDataSource(resultURI, QueryObserver);
  }
}

function deactivateSearch()
{
  /* This stuff doesn't do anything yet.
  var columns = document.getElementById('results-columns').childNodes;
  var column;
  for ( var i=0 ; i<columns.length ; i++ )
  {
    column = columns[i];
    hidden = column.getAttribute('hidden');
    width = column.getAttribute('width');
    sortActive = column.getAttribute('sortActive');
    sortDirection = column.getAttribute('sortDirection');
    ordinal = column.getAttribute('ordinal');
  }
  */
  
  // Save the state of the columns in the results pane so we can set them
  // to this state the next time the user activates this search.
  if (typeof gActiveSearch.isSaved != "undefined" && gActiveSearch.isSaved) 
    persistColumnSettings();
  
  // Reset the columns in the results pane to the default state.
  setColumnSettings(gDefaultColumnSettings);
  
  // Reset the active search and active results.
  gActiveSearch = {};
  var results = getActiveResults();
  results.removeAll();
  
  // Update the state of the search options (Save, Edit, etc.).
  updateSearchOptions();
  
  // Update the results summary line.
  var searchName = document.getElementById('search-name');
  searchName.value = searchName.getAttribute('default');
  var rowCount = document.getElementById('row-count');
  rowCount.value = rowCount.getAttribute('default');
  var loadDate = document.getElementById('load-date');
  loadDate.value = loadDate.getAttribute('default');
  
  // Reset the progress meter.
  resetProgressMeter();
}

var gPersistableColumnAttrs = ['hidden', 'width', 'sortActive', 'sortDirection', 'ordinal'];

function persistColumnSettings()
{
  // Serializes results column settings and saves them to the active search's
  // database entry.
  
  // Don't do anything if the active search isn't saved.
  if (typeof gActiveSearch.uri == "undefined") return;
  
  var settings = getColumnSettings();
    
  var existingSettings = gUserDS.getTarget(gActiveSearch.uri, 'bz:columns');
  if (existingSettings)
    gUserDS.changeLiteral(gActiveSearch.uri, 'bz:columns', existingSettings, settings.toSource());
    else
    gUserDS.assertLiteral(gActiveSearch.uri, 'bz:columns', settings.toSource());
}

function restoreColumnSettings()
{
  if (!gActiveSearch.uri) return;
  
  var settings = gUserDS.getTarget(gActiveSearch.uri, 'bz:columns');
  if (!settings) return;
  
  // Deserialize the column settings from a string representation
  // of a JavaScript object to the object itself.
  eval("settings = " + settings + ";");
  
  setColumnSettings(settings);
}

function getColumnSettings()
{
  var columns = document.getElementById('results-columns').getElementsByTagName('treecol');
  
  var settings = {};
  var column, columnID, attribute;
  for ( var i = 0 ; i < columns.length ; i++ )
  {
    column = columns.item(i);
    columnID = column.getAttribute('id');
    
    settings[columnID] = {};
    for ( var j = 0 ; j < gPersistableColumnAttrs.length ; j++ )
    {
      attribute = gPersistableColumnAttrs[j];
      settings[columnID][attribute] = column.getAttribute(attribute);
    }
  }
  
  return settings;
}

function setColumnSettings(settings)
{
  var column, columnSettings;
  for (var columnID in settings)
  {
    column = document.getElementById(columnID);
    if (!column) continue;
    
    columnSettings = settings[columnID];
    for (var attribute in columnSettings)
      column.setAttribute(attribute, columnSettings[attribute]);
  }
}

  
/*
  var rdfColumns = gUserDS.getContainer(gActiveSearch.uri, "bz:columns");
  if (!rdfColumns) rdfColumns = gUserDS.makeBag(gActiveSearch.uri, "bz:columns");
    id = column.getAttribute('id');
    uri = gActiveSearchURI + "#" + id;
    rdfColumns.appendResource(uri);
    rdfColumns.assertLiteral(uri, 'bz:column_hidden', column.getAttribute('hidden'));
    rdfColumns.assertLiteral(uri, 'bz:column_width', column.getAttribute('width'));
    rdfColumns.assertLiteral(uri, 'bz:column_sort_active', column.getAttribute('sortActive'));
    rdfColumns.assertLiteral(uri, 'bz:column_sort_direction', column.getAttribute('sortDirection'));
    rdfColumns.assertLiteral(uri, 'bz:column_ordinal', column.getAttribute('ordinal'));
*/

function updateSearchOptions()
{
  if (typeof gActiveSearch.isSaved == "undefined")
  {
    // There is no active search.  Disable all buttons.
    document.getElementById('save-command').setAttribute('disabled', 'true');
    document.getElementById('edit-command').setAttribute('disabled', 'true');
    document.getElementById('delete-command').setAttribute('disabled', 'true');
    document.getElementById('refresh-command').setAttribute('disabled', 'true');
    document.getElementById('stop-command').setAttribute('disabled', 'true');
  }
  else
  {
    if (gActiveSearch.state == "loading")
    {
      document.getElementById('stop-command').setAttribute('disabled', 'false');
      document.getElementById('refresh-command').setAttribute('disabled', 'true');
    }
    else
    {
      document.getElementById('stop-command').setAttribute('disabled', 'true');
      document.getElementById('refresh-command').setAttribute('disabled', 'false');
    }
    
    if (gActiveSearch.isSaved)
    {
      document.getElementById('save-command').setAttribute('disabled', 'true');
      document.getElementById('edit-command').setAttribute('disabled', 'false');
      document.getElementById('delete-command').setAttribute('disabled', 'false');
    }
    else 
    {
      document.getElementById('save-command').setAttribute('disabled', 'false');
      document.getElementById('edit-command').setAttribute('disabled', 'true');
      document.getElementById('delete-command').setAttribute('disabled', 'true');
    }
  }
}

function getActiveResults()
{
  if (!gUserDS) return null;
  if (!gUserDS.loaded()) return null;
  var activeResults = 
    gUserDS.getContainer("urn:bugxula:root", "bz:active_results");
  if (!activeResults) 
    activeResults = gUserDS.makeBag("urn:bugxula:root", "bz:active_results");
  return activeResults;
}

function loadBug(url, canOpenBrowser)
{
  // Loads a bug in the content pane if it's visible; otherwise loads it
  // in a browser window if enabled.
  
  // Opening a closed splitter by dragging it rather than by clicking 
  // its grippy puts it into the "" state instead of the "open" state.
  // I'm not sure why that is, but as far as I can tell only open splitters
  // are ever in this empty state, so I equate this state with "open".
  var splitter = document.getElementById('results-content-splitter');
  var state = splitter.getAttribute('state');
  if (state == 'open' || state == '')
  {
    var contentBrowser = document.getElementById('content-browser');
    contentBrowser.setAttribute('src', url);
  }
  else if (canOpenBrowser)
    loadURLInBrowser(url);
}

function loadURLInBrowser(url)
{
  // Get the most recently used browser window, creating one if necessary.
  var navigatorWindow = getNavigatorWindow(true);
  if ( navigatorWindow._content )
  {
    navigatorWindow.loadURI(url);
    navigatorWindow.focus();
  }
  else
  {
    // Escapes quotes in strings being 'eval'ed.  Useful when passing 
    // the URL to load to this function using window.setTimeout.
    function esc(str) { return str.replace(/(['"])/g, "\\$1"); }
    window.setTimeout("loadURLInBrowser('" + esc(url) + "');", 1000);
  }
}


function getNavigatorWindow()
{
  // Returns a reference to a browser window.  Adapted from getNavigatorWindow()
  // in mozilla/xpfe/components/search/resources/search-panel.js.
  
  var navigatorWindow;
  
  // Get the most recently used browser window.
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  windowManager = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  navigatorWindow = windowManager.getMostRecentWindow("navigator:browser");
 
  // If no browser window is available, open a new one.
  if (!navigatorWindow) {
    var navigatorChromeURL = 
      nsPreferences.copyUnicharPref("browser.chromeURL", "chrome://navigator/content/navigator.xul");
    navigatorWindow = openDialog(navigatorChromeURL, "_blank", "chrome,all,dialog=no");
  }
  return navigatorWindow;
}

function populateQuickSearch()
{
  // Populates the quick search bar with the conditions
  // specified by the active search.
  
  var conditions = gActiveSearch.conditions;
  if (!conditions) return;
  
  // Select the installation and update the product menu
  // with the selected installation's products.
  var installationMenu = document.getElementById('search-installation');
  var installationItem = document.getElementById(gActiveSearch.installations[0]);
  if (installationItem) 
    installationMenu.selectedItem = installationItem;
  else 
    installationMenu.selectedIndex = -1;
  updateMenus();
      
  // Set the state to the one specified in the conditions.
  // If no state was specified in the conditions, that is
  // equivalent to bugs in "all" states.
  var stateMenu = document.getElementById('search-state');
  if (conditions.search(/&bug_status=UNCONFIRMED/) != -1)
    stateMenu.value = 'unconfirmed';
  else if (conditions.search(/&bug_status=NEW&bug_status=ASSIGNED&bug_status=REOPENED/) != -1)
    stateMenu.value = 'open';
  else if (conditions.search(/&bug_status=RESOLVED&bug_status=VERIFIED&bug_status=CLOSED/) != -1)
    stateMenu.value = 'closed';
  else
    stateMenu.value = 'all';

  // Reset the product to the first menu item ("any product")
  // and then set it to the product specified in the conditions
  // (if any).
  var productMenu = document.getElementById('search-product');
  productMenu.selectedIndex = 0;
  var productMatch = conditions.match(/product=(\w+)(&|$)/);
  if (productMatch && productMatch.length > 1)
  {
    var product = productMatch[1];
    var productPopup = productMenu.childNodes[1];
    var productItems = 
      productPopup.getElementsByAttribute("value", product);
    if (productItems.length)
      productMenu.selectedItem = productItems[0];
  }
  
  // Set the search field to the one specified in the conditions
  // or reset it to the default field "summary" (second in the list).
  var searchField = document.getElementById('search-field');
  var fieldMatch = conditions.match(/field0-0-0=([^&]+)(&|$)/);
  if (fieldMatch && fieldMatch.length > 1)
    searchField.value = fieldMatch[1];
  else
    searchField.selectedIndex = 1;
  
  // Set the search operator to the one specified in the conditions
  // or reset it to the default operator "contains all of the strings"
  // (the sixth one in the list).
  var searchOperator = document.getElementById('search-operator');
  var operatorMatch = conditions.match(/type0-0-0=(\w+)(&|$)/);
  if (operatorMatch && operatorMatch.length > 1)
    searchOperator.value = operatorMatch[1];
  else
    searchOperator.selectedIndex = 5;
  
  // Set the search term to the one specified in the conditions
  // or reset it to the blank value.
  var searchTerm = document.getElementById('search-term');
  var termMatch = conditions.match(/value0-0-0=([^&]+)/);
  if (termMatch && termMatch.length > 1)
    searchTerm.value = unescape(termMatch[1]);
  else
    searchTerm.value = "";
  
}
